//! This module has side effect.
//! It recommended to include the module by <script> tag.

if (typeof Promise.withResolvers === "undefined") {
  // Chrome/Edge 119, Firefox 121, Safari/iOS 17.4

  // Promise.withResolvers is generic and works with subclasses - the typescript built-in decl
  // could not handle the subclassing case.
  (Promise.prototype as any).withResolvers = function <T>(
    this: AnyPromiseConstructor<T>,
  ) {
    let resolve!: PromiseWithResolvers<T>["resolve"],
      reject!: PromiseWithResolvers<T>["reject"];
    // These variables are expected to be set after `new this()`

    const promise = new this((resolve0, reject0) => {
      resolve = resolve0;
      reject = reject0;
    });

    return {
      promise,
      resolve,
      reject,
    };
  };
}
